﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Aya_Backend.Data.Repositories.UserRepositories
{

    //Mock repository to use for testing. Gets passed mock data in the form of lists upon construction.
    public class MockRepository : IRepository
    {
        private List<User> MockUsers { get; }
        private List<Workbook> MockWorkbooks { get; }
        private List<Workpage> MockWorkpages { get; }

        public MockRepository(List<User> users, List<Workbook> workbooks, List<Workpage> workpages)
        {
            MockUsers = users;
            MockWorkbooks = workbooks;
            MockWorkpages = workpages;
        }

        //User
        public User GetUser(int id)
        {
            return MockUsers.FirstOrDefault(user => user.ID == id);
        }

        public User AddUser(User user)
        {
            MockUsers.Add(user);
            return user;
        }

        //Workbook
        public Workbook GetWorkbook(int id)
        {
            return MockWorkbooks.FirstOrDefault(wb => wb.ID == id);
        }

        public Workbook AddWorkbook(string name, int ownerid)
        {

            var workbook = new Workbook() { ID = 10, Name = name, OwnerID = ownerid };
            MockWorkbooks.Add(workbook);
            return workbook;
        }

        public List<Workbook> GetUserWorkbooks(int id)
        {
            return MockWorkbooks.Where(wb => wb.OwnerID == id).ToList();
        }

        public Workpage GetWorkpage(int id)
        {
            return MockWorkpages.FirstOrDefault(wp => wp.ID == id);
        }

        public void AddWorkpage(Workpage wp)
        {
            MockWorkpages.Add(wp);
        }

        public List<Workpage> GetWorkbookWorkpages(int id)
        {
            return MockWorkpages.Where(wp => wp.WorkbookID == id).ToList();
        }

        public void UpdateWorkbookContent(int id, string content)
        {
            var workpage = MockWorkpages.FirstOrDefault(wp => wp.ID == id);
            workpage.Content = content;
        }

        public Workbook AddWorkbook(string name, string ownerid)
        {
            throw new NotImplementedException();
        }

        public User GetUserAuth(string username, string password)
        {
            throw new NotImplementedException();
        }

        public void UpdateUser(User user)
        {
            throw new NotImplementedException();
        }

        public int GetWorkpageOwnerID(int id)
        {
            throw new NotImplementedException();
        }
    }
}
