export default class API
{
    readonly rootURL: string;
    readonly axios: any;

    constructor(ax: any, root: string)
    {
        this.axios = ax;
        this.rootURL = root;
    }

    async post(path: string, bodyContent: string)
    {
        const res = await this.axios.post(this.rootURL + path, bodyContent, { headers: { "Content-Type": "application/json" }});
        return res;
    }

    async postAuthed(path: string, token: string)
    {
        const res = await this.axios.post(this.rootURL + path, "", { headers: { "Authorization": "Bearer " + token }});
        return res;
    }

    async postAuthedWithBody(path: string, content: string, token: string)
    {
        const res = await this.axios.post(this.rootURL + path, content, { headers: { "Authorization": "Bearer " + token, "Content-Type": "application/json" }, });
        return res;
    }

    async postWithHeaders(path: string, bodyContent: string, options: any)
    {
        const res = await this.axios.post(this.rootURL + path, bodyContent, options);
        return res;
    }

    async get(path: string)
    {
        const res = await this.axios.get(this.rootURL + path);
        return res;
    }

    async getAuthed(path: string, token: string)
    {
        const res = await this.axios.get(this.rootURL + path, { headers: { "Authorization": "Bearer " + token }});
        return res;
    }
}