import Vue from "vue";
import App from "./App.vue";
import router from "./router";
import store from "./store/store";
import { BootstrapVue, IconsPlugin } from 'bootstrap-vue';
import 'bootstrap/dist/css/bootstrap.css';
import 'bootstrap-vue/dist/bootstrap-vue.css';
import { library } from '@fortawesome/fontawesome-svg-core';
import { faUserSecret } from '@fortawesome/free-solid-svg-icons';
import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome';
import VueSimplemde from 'vue-simplemde';
import 'simplemde/dist/simplemde.min.css';
import VModal from 'vue-js-modal';

library.add(faUserSecret);

Vue.use(BootstrapVue);
Vue.use(IconsPlugin);
Vue.use(VModal, { dialog: true });
Vue.component('font-awesome-icon', FontAwesomeIcon);

Vue.component('vue-simplemde', VueSimplemde)

Vue.config.productionTip = false;

new Vue({
  store,
  router,
  render: h => h(App)
}).$mount("#app");
